// Include Standard files
#include "include/AT91SAM7X-EK.h"

/* Global variables */
#define SPEED 		(MCKKHz/1000)
unsigned int LedSpeed = SPEED *10000 ;
const int ledmask[NB_LED]= {LED1, LED2, LED3, LED4};


void wait ( void )
{
    unsigned int waiting_time ;
    for(waiting_time = 0; waiting_time < LedSpeed; waiting_time++) ;
}


int main()
{
    int i;
    
    // d'abord, il faut activer l'horloge sur le PIO
       AT91C_BASE_PMC->PMC_PCER =  (1 << ID_PIO_LED);
    // ensuite, il faut activer l'horloge sur le module UART
       AT91C_BASE_PMC->PMC_PCER =  (1 << ID_UART);

    // Ensuite, on attribue les broche des LEDs au PIO, puis on les configure
    // en sortie.
	BASE_PIO_LED->PIO_PER = LED_MASK; // Set in PIO mode
	BASE_PIO_LED->PIO_OER = LED_MASK; // Configure in Output


    // on commence par initialiser les LED dans l'tat teint
    // on crit dans le registre SODR, pour mettre  '1' car on est en
    // logique inverse
       BASE_PIO_LED->PIO_SODR = LED_MASK ;

    // il faut dfinir que les broches UART_RX_PIN et UART_TX_PIN  ne sont pas en mode PIO
       AT91C_BASE_PIOA-> ...; //  complter
    // puis les attribuer au module A
       AT91C_BASE_PIOA-> ...; //  complter

    // cet accs valide les RX et TX.
       AT91C_BASE_US0->US_CR= AT91C_US_RXEN | AT91C_US_TXEN;
    // il faut mettre le module USART0 (US0) en mode remote loopback
       AT91C_BASE_US0->US_MR= ...; //  complter

    // boucle infinie
    for (;;)
    {
	for ( i=0 ; i < NB_LED-1 ; i++ )
        {
        BASE_PIO_LED->PIO_CODR = ledmask[i] ;
        wait();
        BASE_PIO_LED->PIO_SODR = ledmask[i] ;
        }

        for ( i=(NB_LED-1) ; i > 0 ; i-- )
        {
        BASE_PIO_LED->PIO_CODR = ledmask[i] ;
        wait();
        BASE_PIO_LED->PIO_SODR = ledmask[i] ;
        }
        
        AT91C_BASE_US0->US_THR = 'A';
    }
}
